# Diffusion-Model-Image-Restoration
EE 367 Final Project
## Preprocess
```
python preprocess.py \
--img_dir IMG_DIR \
--size 256 \
--degrad DEGRAD \
--output OUTPUT_DIR
```
Preprocess testing images to the target resolution, generate degraded images, and save all images into output directory.
- ```IMG_DIR```: contains .png images.
- ```DEGRAD```: list of degradation models to apply. You can also pass ``all`` to apply all degradation models. Options: ```sr_bicubic_4```, ```deblur_gauss_1```, ```deblur_gauss_3```, ```color```, ```deno_0.1```, ```deno_0.3```, ```sr_bicubic_4_noisy_0.05```, ```all```.
## Inference
Run SRLDM, DDRM, or DDRM-SRLDM pipelines on preprocessed images. Store the generation results to the output directory and calculate PSNR, SSIM, and MSE scores.
### SRLDM
```
python inference.py \
--input IMG_DIR \
--degrad DEGRAD \
--batch_size 8 \
--num_inference_steps 100 \
--pipeline LDM 
```
### DDRM
```
python inference.py \
--input IMG_DIR \
--output OUTPUT_DIR \
--degrad DEGRAD \
--batch_size 8 \
--num_inference_steps 100 \
--pipeline DDRM \
--config imagenet_256.yml
```
### DDRM-SRLDM
```
python inference.py \
--input IMG_DIR \
--output OUTPUT_DIR \
--degrad DEGRAD \
--batch_size 8 \
--num_inference_steps 100 \
--pipeline DDRM_LDM \
--config ldm_256.yml
```
## Get Intermediate Results
```
python inference.py \
--input IMG_DIR \
--output OUTPUT_DIR \
--degrad DEGRAD \
--batch_size 8 \
--num_inference_steps 100 \
--pipeline [LDM, DDRM, DDRM_LDM] \
--config [imagenet_256.yml, ldm_256.yml] \
--length DATA_LENGTH \
--get_intermediate_results
```
Intermediate results are stored as ```OUTPUT_DIR/[IDX]_[STEP].png```.

### Calculate FID score
Refer to this repository: https://github.com/mseitzer/pytorch-fid.
