import torch.nn.functional as F

class Baseline_pipeline:
    """
        Use upscaled image for super resolution,
        And the degraded image for other tasks as basline
    """
    def __init__(self, size):
        self.size = size 
    def __call__(self, batch):
        output = F.interpolate(batch, size=self.size, mode='bicubic')
        output = (output + 1) * 0.5
        output = output.cpu().permute(0, 2, 3, 1).numpy()
        return output, None