from PIL import Image
import numpy as np
import torch

def postprocess_np(image, channel_dim=-1):
    """
        Input:
            image (np array)
        Output:
            image (np array)
    """
    image = image.squeeze()
    if channel_dim != -1:
        if len(image.shape) == 3:
            image = image.transpose(-2, -1, channel_dim)
        else:
            image = image.transpose(0, -2, -1, channel_dim)
    image = (image + 1.0) / 2
    return image

def np_to_pil(array):
    assert array.shape[2] == 3 and len(array.shape) == 3
    if array.dtype == np.float32:
        array = np.uint8(array * 255)
    return Image.fromarray(array)

def data_transform(X):
    return 2 * X - 1.0

def inverse_data_transform(X):
    X = (X + 1.0) / 2.0
    return torch.clamp(X, 0.0, 1.0)
    